-- scope stuff
gearquipper = gearquipper or {};
local c = gearquipper;

local optionsPanel;

local lblFeatures;
local chIgnoreManuallySwitchedItems;
local lblSaveChanges, chSaveAlways, chSaveCharMenu, chSaveGqMenu, chSaveNever;

local lblVisualSettings;
local chHighlightChanges, chConfirmChangesInChat, chShowCurrentSetLabel, chShowItemTooltip;


local btnReset;

function c:InitOptions()
	c.OPT_VERSION = "OPT_VERSION";
	c.OPT_ACTIONBARS = "OPT_ACTIONBARS";
	c.OPT_NOTIFYCHANGES = "OPT_NOTIFYCHANGES";
	c.OPT_HIGHLIGHTCHANGES = "OPT_HIGHLIGHTCHANGES";
	c.OPT_SAVECHANGES = "OPT_SAVECHANGES";
	c.OPT_SLOTSTATES = "OPT_SLOTSTATES";
	c.OPT_SHOWCURRENTSET = "OPT_SHOWCURRENTSET";
	c.OPT_SHOWITEMTOOLTIP = "OPT_SHOWITEMTOOLTIP";
	c.OPT_IGNOREMANUALITEMS = "OPT_IGNOREMANUALITEMS";

	c.OPT_MENUOPEN = "OPT_MENUOPEN";
	c.OPT_DISABLEEVENTS = "OPT_DISABLEEVENTS";

	c.OPTVALUE_SAVECHANGES_ALWAYS = "OPTVALUE_SAVECHANGES_ALWAYS";
	c.OPTVALUE_SAVECHANGES_CHARMENU = "OPTVALUE_SAVECHANGES_CHARMENU";
	c.OPTVALUE_SAVECHANGES_GQMENU = "OPTVALUE_SAVECHANGES_GQMENU";
	c.OPTVALUE_SAVECHANGES_NEVER = "OPTVALUE_SAVECHANGES_NEVER";

	if GQ_OPTIONS[c.OPT_ACTIONBARS] == nil then
		GQ_OPTIONS[c.OPT_ACTIONBARS] = true;
	end

	if GQ_OPTIONS[c.OPT_NOTIFYCHANGES] == nil then
		GQ_OPTIONS[c.OPT_NOTIFYCHANGES] = true;
	end

	if GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES] == nil then
		GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES] = true;
	end

	if GQ_OPTIONS[c.OPT_SLOTSTATES] == nil then
		GQ_OPTIONS[c.OPT_SLOTSTATES] = false;
	end

	if GQ_OPTIONS[c.OPT_SHOWCURRENTSET] == nil then
		GQ_OPTIONS[c.OPT_SHOWCURRENTSET] = true;
	end

	if GQ_OPTIONS[c.OPT_DISABLEEVENTS] == nil then
		GQ_OPTIONS[c.OPT_DISABLEEVENTS] = false;
	end

	if GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP] == nil then
		GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP] = true;
	end

	if GQ_OPTIONS[c.OPT_IGNOREMANUALITEMS] == nil then
		GQ_OPTIONS[c.OPT_IGNOREMANUALITEMS] = false;
	end

	GQ_OPTIONS[c.OPT_SAVECHANGES] = GQ_OPTIONS[c.OPT_SAVECHANGES] or c.OPTVALUE_SAVECHANGES_CHARMENU;

	optionsPanel = CreateFrame("Frame");
	optionsPanel.name = "GearQuipper";
	optionsPanel.okay = function(self) c:SaveOptions(); end;
	optionsPanel.margin = 10;
	optionsPanel.elementIndex = 1;
	optionsPanel.checkboxYOffset = 22;
	InterfaceOptions_AddCategory(optionsPanel);
	optionsPanel:SetScript("OnShow", function()
		c:ShowOptionsPanel();
	end);
	c:ShowOptionsPanel();

	local S = c:GetElvUiSkinModule();
	if S then
		S:HandleFrame(optionsPanel);
	end
end

function c:ShowOptionsPanel()
	if not lblFeatures then
		lblFeatures = CreateFrame("Frame", "GqUiOptionElement_lblFeatures", optionsPanel);
		lblFeatures:SetPoint("TOPLEFT", optionsPanel.margin, -(optionsPanel.elementIndex - 1) * optionsPanel.checkboxYOffset - optionsPanel.margin);
		lblFeatures:SetWidth(550);
		lblFeatures:SetHeight(23);
		lblFeatures.fontString = lblFeatures:CreateFontString("GqUiOptionElement_lblFeatures_FontString", "ARTWORK", "GameFontNormalLarge");
		lblFeatures.fontString:SetPoint("CENTER");
		lblFeatures.fontString:SetText(c:GetText("Features"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end

	optionsPanel.elementIndex = optionsPanel.elementIndex + 1; -- spacing

	if not lblSaveChanges then
		lblSaveChanges = CreateFrame("Frame", "GqUiOptionElement_lblSaveChanges", optionsPanel);
		lblSaveChanges:SetPoint("TOPLEFT", optionsPanel.margin, -(optionsPanel.elementIndex - 1) * optionsPanel.checkboxYOffset - optionsPanel.margin);
		lblSaveChanges:SetWidth(100);
		lblSaveChanges:SetHeight(23);
		lblSaveChanges.fontString = lblSaveChanges:CreateFontString("GqUiOptionElement_lblSaveChanges_FontString", "ARTWORK", "GameFontNormal");
		lblSaveChanges.fontString:SetPoint("LEFT", 3, 0);
		lblSaveChanges.fontString:SetText(c:GetText("Automatically save changes:"));
	end

	if not chSaveAlways then
		chSaveAlways = c:CreateOptionCheckButton(c:GetText("Always"), 220);
		chSaveAlways:SetScript("OnClick", function(self)
			if self:GetChecked() then
				chSaveCharMenu:SetChecked(false);
				chSaveGqMenu:SetChecked(false);
				chSaveNever:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chSaveAlways:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_ALWAYS);

	if not chSaveCharMenu then
		chSaveCharMenu = c:CreateOptionCheckButton(c:GetText("Character menu open"), 220);
		chSaveCharMenu:SetScript("OnClick", function(self)
			if self:GetChecked() then
				chSaveAlways:SetChecked(false);
				chSaveGqMenu:SetChecked(false);
				chSaveNever:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chSaveCharMenu:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_CHARMENU);

	if not chSaveGqMenu then
		chSaveGqMenu = c:CreateOptionCheckButton(c:GetText("GearQuipper menu open"), 220);
		chSaveGqMenu:SetScript("OnClick", function(self)
			if self:GetChecked() then
				chSaveAlways:SetChecked(false);
				chSaveCharMenu:SetChecked(false);
				chSaveNever:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chSaveGqMenu:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_GQMENU);

	if not chSaveNever then
		chSaveNever = c:CreateOptionCheckButton(c:GetText("Never"), 220);
		chSaveNever:SetScript("OnClick", function(self)
			if self:GetChecked() then
				chSaveAlways:SetChecked(false);
				chSaveCharMenu:SetChecked(false);
				chSaveGqMenu:SetChecked(false);
			else
				self:SetChecked(true);
			end
		end);
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chSaveNever:SetChecked(GQ_OPTIONS[c.OPT_SAVECHANGES] == c.OPTVALUE_SAVECHANGES_NEVER);

	if not chIgnoreManuallySwitchedItems then
		chIgnoreManuallySwitchedItems = c:CreateOptionCheckButton(c:GetText("Ignore manually switched items for the next event triggered set switch"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chIgnoreManuallySwitchedItems:SetChecked(GQ_OPTIONS[c.OPT_IGNOREMANUALITEMS]);

	optionsPanel.elementIndex = optionsPanel.elementIndex + 1; -- spacing
	optionsPanel.elementIndex = optionsPanel.elementIndex + 1; -- spacing

	if not lblVisualSettings then
		lblVisualSettings = CreateFrame("Frame", "GqUiOptionElement_lblVisualSettings", optionsPanel);
		lblVisualSettings:SetPoint("TOPLEFT", optionsPanel.margin, -(optionsPanel.elementIndex - 1) * optionsPanel.checkboxYOffset - optionsPanel.margin);
		lblVisualSettings:SetWidth(550);
		lblVisualSettings:SetHeight(23);
		lblVisualSettings.fontString = lblVisualSettings:CreateFontString("GqUiOptionElement_lblVisualSettings_FontString", "ARTWORK", "GameFontNormalLarge");
		lblVisualSettings.fontString:SetPoint("CENTER");
		lblVisualSettings.fontString:SetText(c:GetText("Visual Settings"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end

	optionsPanel.elementIndex = optionsPanel.elementIndex + 1; -- spacing

	if not chHighlightChanges then
		chHighlightChanges = c:CreateOptionCheckButton(c:GetText("Highlight switched slots"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chHighlightChanges:SetChecked(GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES]);

	if not chConfirmChangesInChat then
		chConfirmChangesInChat = c:CreateOptionCheckButton(c:GetText("Confirm changes in chat"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chConfirmChangesInChat:SetChecked(GQ_OPTIONS[c.OPT_NOTIFYCHANGES]);

	if not chShowCurrentSetLabel then
		chShowCurrentSetLabel = c:CreateOptionCheckButton(c:GetText("Show \"current set\" label"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chShowCurrentSetLabel:SetChecked(GQ_OPTIONS[c.OPT_NOTIFYCHANGES]);

	if not chShowItemTooltip then
		chShowItemTooltip = c:CreateOptionCheckButton(c:GetText("Show item tooltips"));
		optionsPanel.elementIndex = optionsPanel.elementIndex + 1;
	end
	chShowItemTooltip:SetChecked(GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP]);

	if not btnReset then
		btnReset = CreateFrame("Button", "GqResetButton", optionsPanel, "GqButtonTemplate");
		btnReset:SetWidth(180);
		btnReset:SetPoint("TOPLEFT", 10, -optionsPanel.elementIndex * optionsPanel.checkboxYOffset - optionsPanel.margin);
		btnReset:SetScript("OnClick", function() c:ShowResetDialog(); end);
		btnReset.fontString = btnReset:CreateFontString("GqResetButton_FontString", "ARTWORK", "GameFontNormal");
		btnReset.fontString:SetPoint("CENTER");
		btnReset.fontString:SetText(c:GetText("Reset GearQuipper"));

		local S = c:GetElvUiSkinModule();
		if S then
			S:HandleButton(btnReset);
		end
	end
end

function c:CreateOptionCheckButton(text, xOffset)
	xOffset = xOffset or 0;

	local element = CreateFrame("CheckButton", "GqUiOptionElement_" .. optionsPanel.elementIndex, optionsPanel, "ChatConfigCheckButtonTemplate");
	element:SetPoint("TOPLEFT", 10 + xOffset, -(optionsPanel.elementIndex - 1) * optionsPanel.checkboxYOffset - optionsPanel.margin);
	element.fontString = element:CreateFontString("GqUiOptionElement_" .. optionsPanel.elementIndex .. "_FontString", "ARTWORK", "GameFontNormal");
	element.fontString:SetPoint("LEFT", 30, 0);
	element.fontString:SetText(text);

	local S = c:GetElvUiSkinModule();
	if S then
		S:HandleCheckBox(element);
	end

	return element;
end

function c:SaveOptions()
	if c.initFinished then
		GQ_OPTIONS[c.OPT_NOTIFYCHANGES] = chConfirmChangesInChat:GetChecked();
		GQ_OPTIONS[c.OPT_HIGHLIGHTCHANGES] = chHighlightChanges:GetChecked();
		GQ_OPTIONS[c.OPT_SHOWCURRENTSET] = chShowCurrentSetLabel:GetChecked();
		GQ_OPTIONS[c.OPT_SHOWITEMTOOLTIP] = chShowItemTooltip:GetChecked();
		GQ_OPTIONS[c.OPT_IGNOREMANUALITEMS] = chIgnoreManuallySwitchedItems:GetChecked();

		if not GQ_OPTIONS[c.OPT_IGNOREMANUALITEMS] then
			c:ResetIgnoredSlots();
		end

		if chSaveAlways:GetChecked() then
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_ALWAYS;
		elseif chSaveCharMenu:GetChecked() then
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_CHARMENU;
		elseif chSaveGqMenu:GetChecked() then
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_GQMENU;
		else
			GQ_OPTIONS[c.OPT_SAVECHANGES] = c.OPTVALUE_SAVECHANGES_NEVER;
		end
	end
end